// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'StdColors.pas' rev: 6.00

#ifndef StdColorsHPP
#define StdColorsHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Menus.hpp>	// Pascal unit
#include <ImgEdt.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Stdcolors
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS TColorItem;
class PASCALIMPLEMENTATION TColorItem : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	Graphics::TColor FColor;
	
__published:
	__property Graphics::TColor Color = {read=FColor, write=FColor, default=0};
public:
	#pragma option push -w-inl
	/* TCollectionItem.Create */ inline __fastcall virtual TColorItem(Classes::TCollection* Collection) : Classes::TCollectionItem(Collection) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TCollectionItem.Destroy */ inline __fastcall virtual ~TColorItem(void) { }
	#pragma option pop
	
};


class DELPHICLASS TColorCollection;
class DELPHICLASS TCustomColorToolbar;
#pragma option push -b-
enum TColorDirection { cdUpToDown, cdDownToUp, cdLeftToRight, cdRightToLeft };
#pragma option pop

typedef void __fastcall (__closure *TColorChangeEvent)(System::TObject* Sender, Graphics::TColor NewColor);

#pragma option push -b-
enum TDefaultColor { dcVGAGray, dcGrayScaleSmall, dcGrayScaleLarge, dcVGAColors, dcAdvanced };
#pragma option pop

typedef Set<TDefaultColor, dcVGAGray, dcAdvanced>  TDefaultColors;

class PASCALIMPLEMENTATION TCustomColorToolbar : public Controls::TGraphicControl 
{
	typedef Controls::TGraphicControl inherited;
	
private:
	Imgedt::TCustomImageEditor* FEditor;
	TColorCollection* FColors;
	TColorDirection FDirection;
	int FCellSize;
	TColorChangeEvent FOnForeColorChange;
	TColorChangeEvent FOnBackColorChange;
	void __fastcall SetEditor(const Imgedt::TCustomImageEditor* Value);
	void __fastcall SetDirection(const TColorDirection Value);
	void __fastcall SetCellSize(int Value);
	void __fastcall ResizeToolbar(void);
	int __fastcall ColorIndex(int X, int Y);
	MESSAGE void __fastcall WMSize(Messages::TMessage &Message);
	MESSAGE void __fastcall WMLBtnDblClk(Messages::TMessage &Message);
	
protected:
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation);
	DYNAMIC void __fastcall MouseDown(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, int Y);
	virtual void __fastcall Paint(void);
	virtual void __fastcall ForeColorChange(Graphics::TColor NewColor);
	virtual void __fastcall BackColorChange(Graphics::TColor NewColor);
	__property Imgedt::TCustomImageEditor* Editor = {read=FEditor, write=SetEditor};
	__property TColorCollection* Colors = {read=FColors, write=FColors};
	__property TColorDirection Direction = {read=FDirection, write=SetDirection, nodefault};
	__property int CellSize = {read=FCellSize, write=SetCellSize, default=12};
	__property TColorChangeEvent OnForeColorChange = {read=FOnForeColorChange, write=FOnForeColorChange};
	__property TColorChangeEvent OnBackColorChange = {read=FOnBackColorChange, write=FOnBackColorChange};
	
public:
	__fastcall virtual TCustomColorToolbar(Classes::TComponent* AOwner);
	__fastcall virtual ~TCustomColorToolbar(void);
	void __fastcall UpdateColors(void);
	void __fastcall AddColor(Graphics::TColor AColor);
	void __fastcall AddColorDialog(void);
	void __fastcall AddDefaultColors(TDefaultColors DefaultColors, bool DeleteCurrent);
	void __fastcall SaveColorsToStream(Classes::TStream* S);
	void __fastcall LoadColorsFromStream(Classes::TStream* S);
	void __fastcall SaveColorsToFile(const AnsiString FileName);
	void __fastcall LoadColorsFromFile(const AnsiString FileName);
};


class PASCALIMPLEMENTATION TColorCollection : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
public:
	TColorItem* operator[](int Index) { return Items[Index]; }
	
private:
	TCustomColorToolbar* FToolbar;
	TColorItem* __fastcall GetColorItem(int Index);
	void __fastcall SetColorItem(int Index, TColorItem* Value);
	
protected:
	DYNAMIC Classes::TPersistent* __fastcall GetOwner(void);
	
public:
	__fastcall TColorCollection(TCustomColorToolbar* AToolbar);
	HIDESBASE TColorItem* __fastcall Add(void);
	__property TColorItem* Items[int Index] = {read=GetColorItem, write=SetColorItem/*, default*/};
public:
	#pragma option push -w-inl
	/* TCollection.Destroy */ inline __fastcall virtual ~TColorCollection(void) { }
	#pragma option pop
	
};


class DELPHICLASS TColorToolbar;
class PASCALIMPLEMENTATION TColorToolbar : public TCustomColorToolbar 
{
	typedef TCustomColorToolbar inherited;
	
__published:
	__property PopupMenu ;
	__property DragCursor  = {default=-12};
	__property DragMode  = {default=0};
	__property ParentColor  = {default=1};
	__property Color  = {default=-2147483643};
	__property ShowHint ;
	__property ParentShowHint  = {default=1};
	__property Editor ;
	__property Colors ;
	__property Direction ;
	__property CellSize  = {default=12};
	__property OnClick ;
	__property OnDblClick ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEndDrag ;
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;
	__property OnStartDrag ;
	__property OnForeColorChange ;
	__property OnBackColorChange ;
public:
	#pragma option push -w-inl
	/* TCustomColorToolbar.Create */ inline __fastcall virtual TColorToolbar(Classes::TComponent* AOwner) : TCustomColorToolbar(AOwner) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TCustomColorToolbar.Destroy */ inline __fastcall virtual ~TColorToolbar(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE void __fastcall Register(void);

}	/* namespace Stdcolors */
using namespace Stdcolors;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// StdColors
