// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'PJGrid.pas' rev: 6.00

#ifndef PJGridHPP
#define PJGridHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <PSJob.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Pjgrid
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TCellBorder { cbTop, cbLeft, cbRight, cbBottom };
#pragma option pop

typedef Set<TCellBorder, cbTop, cbBottom>  TCellBorders;

#pragma option push -b-
enum TCellType { ctTable, ctHeader, ctPage, ctFooter };
#pragma option pop

typedef void __fastcall (__closure *TColWidthEvent)(System::TObject* Sender, Graphics::TCanvas* TheCanvas, int ACol, int &ColWidth);

typedef void __fastcall (__closure *TColSubpageEvent)(System::TObject* Sender, int ACol, int &ColSubpage);

typedef void __fastcall (__closure *TDrawCellEvent)(System::TObject* Sender, Graphics::TCanvas* TheCanvas, const Types::TRect &TheRect, int PageIndex, int ACol, int ARow, Psjob::TDrawTarget Target);

typedef void __fastcall (__closure *TCustomizeCellCanvas)(System::TObject* Sender, int ACol, int ARow, Graphics::TCanvas* TheCanvas);

class DELPHICLASS TCustomGridPrintJob;
class PASCALIMPLEMENTATION TCustomGridPrintJob : public Psjob::TCustomPrintJob 
{
	typedef Psjob::TCustomPrintJob inherited;
	
private:
	int FColCount;
	int FRowCount;
	int FRowsPerPage;
	int FPagesPerRow;
	TCellBorders FTableBorders;
	TCellBorders FHeaderCellBorders;
	TCellBorders FPageCellBorders;
	TCellBorders FFooterCellBorders;
	bool FIndexColumn;
	int FIndexStart;
	TColSubpageEvent FOnColSubpage;
	TCustomizeCellCanvas FOnCustomizeCellCanvas;
	void __fastcall SetColCount(const int Value);
	void __fastcall SetRowCount(const int Value);
	void __fastcall SetRowsPerPage(const int Value);
	void __fastcall SetPagesPerRow(const int Value);
	void __fastcall SetTableBorders(const TCellBorders Value);
	void __fastcall SetHeaderCellBorders(const TCellBorders Value);
	void __fastcall SetPageCellBorders(const TCellBorders Value);
	void __fastcall SetFooterCellBorders(const TCellBorders Value);
	void __fastcall SetIndexColumn(const bool Value);
	void __fastcall SetIndexStart(const int Value);
	int __fastcall GetRowTop(const Types::TRect &R, int PageIndex, int Row);
	
protected:
	__property int ColCount = {read=FColCount, write=SetColCount, default=1};
	__property int RowCount = {read=FRowCount, write=SetRowCount, default=1};
	__property int RowsPerPage = {read=FRowsPerPage, write=SetRowsPerPage, default=1};
	__property int PagesPerRow = {read=FPagesPerRow, write=SetPagesPerRow, default=1};
	__property TCellBorders TableBorders = {read=FTableBorders, write=SetTableBorders, default=0};
	__property TCellBorders HeaderCellBorders = {read=FHeaderCellBorders, write=SetHeaderCellBorders, default=0};
	__property TCellBorders PageCellBorders = {read=FPageCellBorders, write=SetPageCellBorders, default=0};
	__property TCellBorders FooterCellBorders = {read=FFooterCellBorders, write=SetFooterCellBorders, default=0};
	__property bool IndexColumn = {read=FIndexColumn, write=SetIndexColumn, default=0};
	__property int IndexStart = {read=FIndexStart, write=SetIndexStart, default=0};
	__property TColSubpageEvent OnColSubpage = {read=FOnColSubpage, write=FOnColSubpage};
	__property TCustomizeCellCanvas OnCustomizeCellCanvas = {read=FOnCustomizeCellCanvas, write=FOnCustomizeCellCanvas};
	
public:
	__fastcall virtual TCustomGridPrintJob(Classes::TComponent* AOwner);
	virtual void __fastcall DrawCell(Graphics::TCanvas* TheCanvas, const Types::TRect &TheRect, int PageIndex, int ACol, int ARow, Psjob::TDrawTarget Target) = 0 ;
	virtual void __fastcall CustomizeCellCanvas(int ACol, int ARow, Graphics::TCanvas* TheCanvas);
	virtual void __fastcall DrawBorders(Graphics::TCanvas* TheCanvas, const Types::TRect &TheRect, TCellType CellType, Psjob::TDrawTarget Target);
	virtual void __fastcall DrawArea(Graphics::TCanvas* TheCanvas, int PageIndex, const Types::TRect &TheRect, Psjob::TDrawArea Area, Psjob::TDrawTarget Target);
	virtual int __fastcall GetColWidth(Graphics::TCanvas* TheCanvas, int ACol);
	virtual int __fastcall GetColSubpage(int ACol);
public:
	#pragma option push -w-inl
	/* TCustomPrintJob.Destroy */ inline __fastcall virtual ~TCustomGridPrintJob(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
static const int rowHeader = 0x80000001;
static const int rowFooter = 0x7fffffff;
static const Shortint colIndex = 0xffffffff;

}	/* namespace Pjgrid */
using namespace Pjgrid;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// PJGrid
