// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'PropList.pas' rev: 6.00

#ifndef PropListHPP
#define PropListHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Menus.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <TypInfo.hpp>	// Pascal unit
#include <Variants.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Proplist
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS EPropertyException;
class PASCALIMPLEMENTATION EPropertyException : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	#pragma option push -w-inl
	/* Exception.Create */ inline __fastcall EPropertyException(const AnsiString Msg) : Sysutils::Exception(Msg) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EPropertyException(const AnsiString Msg, const System::TVarRec * Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EPropertyException(int Ident)/* overload */ : Sysutils::Exception(Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EPropertyException(int Ident, const System::TVarRec * Args, const int Args_Size)/* overload */ : Sysutils::Exception(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EPropertyException(const AnsiString Msg, int AHelpContext) : Sysutils::Exception(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EPropertyException(const AnsiString Msg, const System::TVarRec * Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EPropertyException(int Ident, int AHelpContext)/* overload */ : Sysutils::Exception(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EPropertyException(System::PResStringRec ResStringRec, const System::TVarRec * Args, const int Args_Size, int AHelpContext)/* overload */ : Sysutils::Exception(ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~EPropertyException(void) { }
	#pragma option pop
	
};


class DELPHICLASS TProperty;
typedef AnsiString __fastcall (*TGetPropertyValue)(Classes::TPersistent* AInstance, TProperty* Prop);

typedef void __fastcall (*TSetPropertyValue)(Classes::TPersistent* AInstance, TProperty* Prop, AnsiString Value);

class DELPHICLASS TCustomPropData;
class PASCALIMPLEMENTATION TCustomPropData : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	TMetaClass*InstanceType;
	System::ShortString PropName;
	Typinfo::TTypeInfo *PropType;
	bool Descendants;
	TGetPropertyValue GetProc;
	TSetPropertyValue SetProc;
	__fastcall TCustomPropData(TMetaClass* AInstanceType,  System::ShortString &APropName, Typinfo::PTypeInfo APropType, bool ADescendants, TGetPropertyValue AGetProc, TSetPropertyValue ASetProc);
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TCustomPropData(void) { }
	#pragma option pop
	
};


class DELPHICLASS TPropertyList;
class PASCALIMPLEMENTATION TPropertyList : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	TProperty* operator[](int Index) { return Properties[Index]; }
	
private:
	TProperty* FOwner;
	Classes::TList* FProperties;
	Classes::TComponent* FRoot;
	Classes::TComponent* FInstance;
	TPropertyList* __fastcall GetOwnerList(void);
	int __fastcall GetLevel(void);
	int __fastcall GetCount(void);
	TProperty* __fastcall GetProperty(int AIndex);
	void __fastcall SetRoot(const Classes::TComponent* Value);
	void __fastcall SetInstance(const Classes::TComponent* Value);
	void __fastcall Clear(void);
	void __fastcall Sort(void);
	
public:
	__fastcall virtual TPropertyList(TProperty* AOwner);
	__fastcall virtual ~TPropertyList(void);
	virtual TProperty* __fastcall CreateProperty(Typinfo::PPropInfo APropInfo, TCustomPropData* APropData);
	virtual void __fastcall AddEmulated(TProperty* P);
	virtual void __fastcall Update(void);
	virtual int __fastcall Compare(TProperty* P1, TProperty* P2);
	virtual bool __fastcall Filter(TProperty* P);
	int __fastcall IndexOf(const TProperty* Item);
	int __fastcall IndexOfName(const AnsiString Name);
	TProperty* __fastcall FindProperty(const AnsiString Name);
	__property TPropertyList* OwnerList = {read=GetOwnerList};
	__property int Level = {read=GetLevel, nodefault};
	__property TProperty* Properties[int Index] = {read=GetProperty/*, default*/};
	__property int Count = {read=GetCount, nodefault};
	__property TProperty* Owner = {read=FOwner};
	__property Classes::TComponent* Root = {read=FRoot, write=SetRoot};
	__property Classes::TComponent* Instance = {read=FInstance, write=SetInstance};
};


class PASCALIMPLEMENTATION TProperty : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	TPropertyList* FOwner;
	Classes::TComponent* FRoot;
	Classes::TPersistent* FInstance;
	Typinfo::TPropInfo *FPropInfo;
	Typinfo::TTypeData *FTypeData;
	TPropertyList* FProperties;
	TCustomPropData* FPropData;
	bool __fastcall GetEmulated(void);
	bool __fastcall GetCustom(void);
	TProperty* __fastcall GetOwnerProperty(void);
	int __fastcall GetLevel(void);
	Typinfo::PTypeInfo __fastcall GetPropType(void);
	void * __fastcall GetGetProc(void);
	void * __fastcall GetSetProc(void);
	bool __fastcall GetIsStored(void);
	short __fastcall GetIndex(void);
	int __fastcall GetDefault(void);
	short __fastcall GetNameIndex(void);
	System::ShortString __fastcall GetName();
	System::ShortString __fastcall GetFullName();
	AnsiString __fastcall GetTypeName();
	Typinfo::TTypeKind __fastcall GetTypeKind(void);
	Typinfo::TOrdType __fastcall GetOrdType(void);
	int __fastcall GetMinValue(void);
	int __fastcall GetMaxValue(void);
	Typinfo::PTypeInfo __fastcall GetCompType(void);
	Typinfo::PTypeInfo __fastcall GetBaseType(void);
	int __fastcall GetEnumCount(void);
	AnsiString __fastcall GetEName(int Value);
	int __fastcall GetEValue(AnsiString Value);
	Typinfo::TFloatType __fastcall GetFloatType(void);
	Byte __fastcall GetMaxLength(void);
	TMetaClass* __fastcall GetClassType(void);
	Typinfo::PTypeInfo __fastcall GetParentInfo(void);
	System::ShortString __fastcall GetUnitName();
	Typinfo::TMethodKind __fastcall GetMethodKind(void);
	int __fastcall GetParamCount(void);
	Typinfo::TParamFlags __fastcall GetParamFlags(int Index);
	System::ShortString __fastcall GetParamName(int Index);
	System::ShortString __fastcall GetParamType(int Index);
	System::ShortString __fastcall GetParameter(int Index);
	System::ShortString __fastcall GetResultType();
	AnsiString __fastcall GetMethodDeclaration();
	Typinfo::PTypeInfo __fastcall GetIntfParent(void);
	Typinfo::TIntfFlags __fastcall GetIntfFlags(void);
	GUID __fastcall GetGUID();
	System::ShortString __fastcall GetIntfUnit();
	__int64 __fastcall GetMinInt64Value(void);
	__int64 __fastcall GetMaxInt64Value(void);
	Extended __fastcall GetAsFloat(void);
	void __fastcall SetAsFloat(const Extended Value);
	System::TMethod __fastcall GetAsMethod();
	void __fastcall SetAsMethod(const System::TMethod &Value);
	int __fastcall GetAsInteger(void);
	void __fastcall SetAsInteger(const int Value);
	char __fastcall GetAsChar(void);
	void __fastcall SetAsChar(const char Value);
	bool __fastcall GetAsBoolean(void);
	void __fastcall SetAsBoolean(const bool Value);
	System::TObject* __fastcall GetAsObject(void);
	void __fastcall SetAsObject(const System::TObject* Value);
	System::TDateTime __fastcall GetAsDateTime(void);
	void __fastcall SetAsDateTime(const System::TDateTime Value);
	TDate __fastcall GetAsDate(void);
	void __fastcall SetAsDate(const TDate Value);
	TTime __fastcall GetAsTime(void);
	void __fastcall SetAsTime(const TTime Value);
	WideString __fastcall GetAsString();
	void __fastcall SetAsString(const WideString Value);
	Variant __fastcall GetAsVariant();
	void __fastcall SetAsVariant(const Variant &Value);
	System::_di_IInterface __fastcall GetAsInterface();
	void __fastcall SetAsInterface(const System::_di_IInterface Value);
	
public:
	__fastcall virtual TProperty(TPropertyList* AOwner, Classes::TComponent* ARoot, Classes::TComponent* AInstance, Typinfo::PPropInfo APropInfo, TCustomPropData* APropData);
	__fastcall virtual ~TProperty(void);
	void __fastcall Assign(TProperty* Source);
	virtual TPropertyList* __fastcall CreatePropertyList(void);
	virtual AnsiString __fastcall DisplayValue();
	virtual WideString __fastcall GetStringValue();
	virtual void __fastcall SetStringValue(const WideString Value);
	virtual void __fastcall ValuesList(const Classes::TStrings* Values);
	bool __fastcall IsCompatibleObject(System::TObject* AObject);
	bool __fastcall IsCompatibleType(Typinfo::PTypeInfo ATypeInfo);
	bool __fastcall IsType(Typinfo::PTypeInfo ATypeInfo);
	bool __fastcall IsCompatible(TProperty* P);
	__property bool Emulated = {read=GetEmulated, nodefault};
	__property bool Custom = {read=GetCustom, nodefault};
	__property TPropertyList* Owner = {read=FOwner};
	__property TProperty* OwnerProperty = {read=GetOwnerProperty};
	__property int Level = {read=GetLevel, nodefault};
	__property Classes::TComponent* Root = {read=FRoot, write=FRoot};
	__property Classes::TPersistent* Instance = {read=FInstance, write=FInstance};
	__property Typinfo::PTypeData TypeData = {read=FTypeData};
	__property Typinfo::PTypeInfo PropType = {read=GetPropType};
	__property void * GetProc = {read=GetGetProc};
	__property void * SetProc = {read=GetSetProc};
	__property bool IsStored = {read=GetIsStored, nodefault};
	__property short Index = {read=GetIndex, nodefault};
	__property int Default = {read=GetDefault, nodefault};
	__property short NameIndex = {read=GetNameIndex, nodefault};
	__property System::ShortString Name = {read=GetName};
	__property System::ShortString FullName = {read=GetFullName};
	__property AnsiString TypeName = {read=GetTypeName};
	__property Typinfo::TTypeKind TypeKind = {read=GetTypeKind, nodefault};
	__property Typinfo::TOrdType OrdType = {read=GetOrdType, nodefault};
	__property int MinValue = {read=GetMinValue, nodefault};
	__property int MaxValue = {read=GetMaxValue, nodefault};
	__property Typinfo::PTypeInfo BaseType = {read=GetBaseType};
	__property int EnumCount = {read=GetEnumCount, nodefault};
	__property AnsiString Names[int Index] = {read=GetEName};
	__property int Values[AnsiString Index] = {read=GetEValue};
	__property Typinfo::PTypeInfo CompType = {read=GetCompType};
	__property Typinfo::TFloatType FloatType = {read=GetFloatType, nodefault};
	__property Byte MaxLength = {read=GetMaxLength, nodefault};
	__property TMetaClass* PropClassType = {read=GetClassType};
	__property Typinfo::PTypeInfo ParentInfo = {read=GetParentInfo};
	__property System::ShortString UnitName = {read=GetUnitName};
	__property TPropertyList* Properties = {read=FProperties};
	__property Typinfo::TMethodKind MethodKind = {read=GetMethodKind, nodefault};
	__property int ParamCount = {read=GetParamCount, nodefault};
	__property Typinfo::TParamFlags ParamFlags[int Index] = {read=GetParamFlags};
	__property System::ShortString ParamNames[int Index] = {read=GetParamName};
	__property System::ShortString ParamTypes[int Index] = {read=GetParamType};
	__property System::ShortString Parameters[int Index] = {read=GetParameter};
	__property System::ShortString ResultType = {read=GetResultType};
	__property AnsiString MethodDeclaration = {read=GetMethodDeclaration};
	__property Typinfo::PTypeInfo IntfParent = {read=GetIntfParent};
	__property Typinfo::TIntfFlags IntfFlags = {read=GetIntfFlags, nodefault};
	__property GUID GUID = {read=GetGUID};
	__property System::ShortString IntfUnit = {read=GetIntfUnit};
	__property __int64 MinInt64Value = {read=GetMinInt64Value};
	__property __int64 MaxInt64Value = {read=GetMaxInt64Value};
	__property Extended AsFloat = {read=GetAsFloat, write=SetAsFloat};
	__property System::TMethod AsMethod = {read=GetAsMethod, write=SetAsMethod};
	__property int AsInteger = {read=GetAsInteger, write=SetAsInteger, nodefault};
	__property char AsChar = {read=GetAsChar, write=SetAsChar, nodefault};
	__property bool AsBoolean = {read=GetAsBoolean, write=SetAsBoolean, nodefault};
	__property System::TObject* AsObject = {read=GetAsObject, write=SetAsObject};
	__property System::TDateTime AsDateTime = {read=GetAsDateTime, write=SetAsDateTime};
	__property TDate AsDate = {read=GetAsDate, write=SetAsDate};
	__property TTime AsTime = {read=GetAsTime, write=SetAsTime};
	__property WideString AsString = {read=GetAsString, write=SetAsString};
	__property Variant AsVariant = {read=GetAsVariant, write=SetAsVariant};
	__property System::_di_IInterface AsInterface = {read=GetAsInterface, write=SetAsInterface};
};


typedef int __fastcall (__closure *TCompareMethod)(TProperty* P1, TProperty* P2);

//-- var, const, procedure ---------------------------------------------------
extern PACKAGE System::ResourceString _strPropListInvalidValue;
#define Proplist_strPropListInvalidValue System::LoadResourceString(&Proplist::_strPropListInvalidValue)
#define tkOrdinals (System::Set<Typinfo::TTypeKind, tkUnknown, tkDynArray> () << Typinfo::TTypeKind(1) << Typinfo::TTypeKind(2) << Typinfo::TTypeKind(3) << Typinfo::TTypeKind(6) << Typinfo::TTypeKind(7) << Typinfo::TTypeKind(9) )
#define tkChars (System::Set<Typinfo::TTypeKind, tkUnknown, tkDynArray> () << Typinfo::TTypeKind(2) << Typinfo::TTypeKind(9) )
#define tkStrings (System::Set<Typinfo::TTypeKind, tkUnknown, tkDynArray> () << Typinfo::TTypeKind(5) << Typinfo::TTypeKind(10) << Typinfo::TTypeKind(11) )
extern PACKAGE void __fastcall RegisterCustomProperty(TMetaClass* AInstanceType,  System::ShortString &APropName, Typinfo::PTypeInfo APropType, bool ADescendants, TGetPropertyValue AGetProc, TSetPropertyValue ASetProc);
extern PACKAGE bool __fastcall RegisteredProperty(TMetaClass* AInstanceType,  System::ShortString &APropName);
extern PACKAGE void __fastcall UnregisterCustomProperty(TMetaClass* AInstanceType,  System::ShortString &APropName);
extern PACKAGE void __fastcall UnregisterCustomProperties(void);

}	/* namespace Proplist */
using namespace Proplist;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// PropList
